<template>
  <div>
    <UpsertContact v-model="showCreateContactModal" />
    <Navbar
      :showCreateContact="showCreateContactButton"
      @createContact="showCreateContactModal = true"
      @search="search"
    />
    <slot />
  </div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from '@vue/composition-api';
import { Navbar } from '@/components';
import { UpsertContact } from '@/containers';
import { useStore } from '@/store';

export default defineComponent({
  name: 'Default',
  components: {
    Navbar,
    UpsertContact,
  },

  setup() {
    const { getters, dispatch } = useStore();
    const showCreateContactButton = computed(() => getters.hasContacts);

    const showCreateContactModal = ref(false);

    const search = (text: string) => {
      dispatch('search', text);
    };

    return { showCreateContactButton, showCreateContactModal, search };
  },
});
</script>
